Open Babel: OBMol Class Reference

Public Member Functions | Protected Member Functions | Protected Attributes

# OBMol Class Reference

Molecule Class. More...

`#include <openbabel/mol.h>`

Inheritance diagram for OBMol:

List of all members.

## Public Member Functions
template<class T >
T * | CastAndClear (bool clear=true)
Initialization and data (re)size methods
| OBMol ()
| OBMol (const OBMol &)
virtual | ~OBMol ()
OBMol & | operator= (const OBMol &mol)
OBMol & | operator+= (const OBMol &mol)
void | ReserveAtoms (int natoms)
virtual OBAtom * | CreateAtom (void)
virtual OBBond * | CreateBond (void)
virtual OBResidue * | CreateResidue (void)
virtual void | DestroyAtom (OBAtom *)
virtual void | DestroyBond (OBBond *)
virtual void | DestroyResidue (OBResidue *)
bool | AddAtom (OBAtom &)
bool | InsertAtom (OBAtom &)
bool | AddBond (int beginIdx, int endIdx, int order, int flags=0, int insertpos=-1)
bool | AddBond (OBBond &)
bool | AddResidue (OBResidue &)
OBAtom * | NewAtom ()
OBAtom * | NewAtom (unsigned long id)
OBBond * | NewBond ()
OBBond * | NewBond (unsigned long id)
OBResidue * | NewResidue ()
bool | DeleteAtom (OBAtom *, bool destroyAtom=true)
bool | DeleteBond (OBBond *, bool destroyBond=true)
bool | DeleteResidue (OBResidue *, bool destroyResidue=true)
Data retrieval methods
int | GetFlags ()
const char * | GetTitle (bool replaceNewlines=true) const
unsigned int | NumAtoms () const
unsigned int | NumBonds () const
unsigned int | NumHvyAtoms ()
unsigned int | NumResidues () const
unsigned int | NumRotors ()
OBAtom * | GetAtom (int idx) const
OBAtom * | GetAtomById (unsigned long id) const
OBAtom * | GetFirstAtom () const
OBBond * | GetBond (int idx) const
OBBond * | GetBondById (unsigned long id) const
OBBond * | GetBond (int a, int b) const
OBBond * | GetBond (OBAtom *bgn, OBAtom *end) const
OBResidue * | GetResidue (int idx) const
std::vector< OBInternalCoord * > | GetInternalCoord ()
double | GetTorsion (int, int, int, int)
double | GetTorsion (OBAtom *a, OBAtom *b, OBAtom *c, OBAtom *d)
double | GetAngle (OBAtom *a, OBAtom *b, OBAtom *c)
std::string | GetFormula ()
std::string | GetSpacedFormula (int ones=0, const char *sp=" ", bool implicitH=true)
double | GetEnergy () const
double | GetMolWt (bool implicitH=true)
double | GetExactMass (bool implicitH=true)
int | GetTotalCharge ()
unsigned int | GetTotalSpinMultiplicity ()
unsigned short int | GetDimension () const
double * | GetCoordinates ()
std::vector< OBRing * > & | GetSSSR ()
std::vector< OBRing * > & | GetLSSR ()
bool | AutomaticFormalCharge ()
bool | AutomaticPartialCharge ()
Data modification methods
void | SetTitle (const char *title)
void | SetTitle (std::string &title)
void | SetFormula (std::string molFormula)
void | SetEnergy (double energy)
void | SetDimension (unsigned short int d)
void | SetTotalCharge (int charge)
void | SetTotalSpinMultiplicity (unsigned int spinMultiplicity)
void | SetInternalCoord (std::vector< OBInternalCoord * > int_coord)
void | SetAutomaticFormalCharge (bool val)
void | SetAutomaticPartialCharge (bool val)
void | SetAromaticPerceived ()
void | SetSSSRPerceived ()
void | SetLSSRPerceived ()
void | SetRingAtomsAndBondsPerceived ()
void | SetAtomTypesPerceived ()
void | SetRingTypesPerceived ()
void | SetChainsPerceived ()
void | SetChiralityPerceived ()
void | SetPartialChargesPerceived ()
void | SetHybridizationPerceived ()
void | SetImplicitValencePerceived ()
void | SetKekulePerceived ()
void | SetClosureBondsPerceived ()
void | SetHydrogensAdded ()
void | SetCorrectedForPH ()
void | SetAromaticCorrected ()
void | SetSpinMultiplicityAssigned ()
void | SetFlags (int flags)
void | UnsetAromaticPerceived ()
void | UnsetSSSRPerceived ()
void | UnsetRingTypesPerceived ()
void | UnsetPartialChargesPerceived ()
void | UnsetImplicitValencePerceived ()
void | UnsetHydrogensAdded ()
void | UnsetFlag (int flag)
Molecule utilities and perception methods
void | FindSSSR ()
void | FindLSSR ()
void | FindRingAtomsAndBonds ()
void | FindChiralCenters ()
void | FindChildren (std::vector< int > &children, int bgnIdx, int endIdx)
void | FindChildren (std::vector< OBAtom * > &children, OBAtom *bgn, OBAtom *end)
void | FindLargestFragment (OBBitVec &frag)
void | ContigFragList (std::vector< std::vector< int > > &)
void | Align (OBAtom *, OBAtom *, vector3 &, vector3 &)
void | ConnectTheDots ()
void | PerceiveBondOrders ()
void | FindAngles ()
void | FindTorsions ()
bool | GetGTDVector (std::vector< int > &)
void | GetGIVector (std::vector< unsigned int > &)
void | GetGIDVector (std::vector< unsigned int > &)
Methods to check for existence of properties
bool | Has2D (bool Not3D=false)
bool | Has3D ()
bool | HasNonZeroCoords ()
bool | HasAromaticPerceived ()
bool | HasSSSRPerceived ()
bool | HasLSSRPerceived ()
bool | HasRingAtomsAndBondsPerceived ()
bool | HasAtomTypesPerceived ()
bool | HasRingTypesPerceived ()
bool | HasChiralityPerceived ()
bool | HasPartialChargesPerceived ()
bool | HasHybridizationPerceived ()
bool | HasImplicitValencePerceived ()
bool | HasKekulePerceived ()
bool | HasClosureBondsPerceived ()
bool | HasChainsPerceived ()
bool | HasHydrogensAdded ()
bool | HasAromaticCorrected ()
bool | IsCorrectedForPH ()
bool | HasSpinMultiplicityAssigned ()
bool | IsChiral ()
bool | Empty ()
Multiple conformer member functions
int | NumConformers ()
void | SetConformers (std::vector< double * > &v)
void | AddConformer (double *f)
void | SetConformer (int i)
void | CopyConformer (double *c, int nconf)
void | DeleteConformer (int nconf)
double * | GetConformer (int i)
void | SetEnergies (std::vector< double > &energies)
std::vector< double > | GetEnergies ()
double | GetEnergy (int ci)
double * | BeginConformer (std::vector< double * >::iterator &i)
double * | NextConformer (std::vector< double * >::iterator &i)
std::vector< double * > & | GetConformers ()
Iterator methods
OBAtomIterator | BeginAtoms ()
OBAtomIterator | EndAtoms ()
OBBondIterator | BeginBonds ()
OBBondIterator | EndBonds ()
OBResidueIterator | BeginResidues ()
OBResidueIterator | EndResidues ()
OBAtom * | BeginAtom (OBAtomIterator &i)
OBAtom * | NextAtom (OBAtomIterator &i)
OBBond * | BeginBond (OBBondIterator &i)
OBBond * | NextBond (OBBondIterator &i)
OBResidue * | BeginResidue (OBResidueIterator &i)
OBResidue * | NextResidue (OBResidueIterator &i)
OBInternalCoord * | BeginInternalCoord (std::vector< OBInternalCoord * >::iterator &i)
OBInternalCoord * | NextInternalCoord (std::vector< OBInternalCoord * >::iterator &i)
Generic data handling methods (via OBGenericData)
bool | HasData (const std::string &)
bool | HasData (const char *)
bool | HasData (const unsigned int type)
void | DeleteData (unsigned int type)
void | DeleteData (OBGenericData *)
void | DeleteData (std::vector< OBGenericData * > &)
bool | DeleteData (const std::string &s)
void | SetData (OBGenericData *d)
void | CloneData (OBGenericData *d)
size_t | DataSize () const
OBGenericData * | GetData (const unsigned int type)
OBGenericData * | GetData (const std::string &)
OBGenericData * | GetData (const char *)
std::vector< OBGenericData * > & | GetData ()
std::vector< OBGenericData * > | GetData (DataOrigin source)
std::vector< OBGenericData * > | GetAllData (const unsigned int type)
OBDataIterator | BeginData ()
OBDataIterator | EndData ()
## Protected Member Functions
bool | HasFlag (int flag)
void | SetFlag (int flag)
Internal Kekulization routines -- see kekulize.cpp and NewPerceiveKekuleBonds()
void | start_kekulize (std::vector< OBAtom * > &cycle, std::vector< int > &electron)
bool | expand_kekulize (int bond_idx, std::vector< int > &atomState, std::vector< int > &bondState)
bool | has_no_leftover_electrons (std::vector< int > &atomState)
int | getorden (OBAtom *atom)
bool | expandcycle (OBAtom *atom, OBBitVec &avisit, const OBBitVec &potAromBonds)
## Protected Attributes
int | _flags
bool | _autoPartialCharge
bool | _autoFormalCharge
std::string | _title
std::vector< OBAtom * > | _vatom
std::vector< OBAtom * > | _atomIds
std::vector< OBBond * > | _vbond
std::vector< OBBond * > | _bondIds
unsigned short int | _dimension
int | _totalCharge
unsigned int | _totalSpin
double * | _c
std::vector< double * > | _vconf
double | _energy
unsigned int | _natoms
unsigned int | _nbonds
std::vector< OBResidue * > | _residue
std::vector< OBInternalCoord * > | _internals
unsigned short int | _mod
std::vector< OBGenericData * > | _vdata
## Molecule modification methods
virtual void | BeginModify (void)
virtual void | EndModify (bool nukePerceivedData=true)
int | GetMod ()
void | IncrementMod ()
void | DecrementMod ()
virtual OBBase * | DoTransformations (const std::map< std::string, std::string > *pOptions, OBConversion *pConv)
bool | Clear ()
void | RenumberAtoms (std::vector< OBAtom * > &)
void | RenumberAtoms (std::vector< int >)
void | SetCoordinates (double *c)
void | ToInertialFrame (int conf, double *rmat)
void | ToInertialFrame ()
void | Translate (const vector3 &v)
void | Translate (const vector3 &v, int conf)
void | Rotate (const double u[3][3])
void | Rotate (const double m[9])
void | Rotate (const double m[9], int nconf)
void | Center ()
bool | Kekulize ()
bool | PerceiveKekuleBonds ()
void | NewPerceiveKekuleBonds ()
bool | DeleteHydrogens ()
bool | DeleteHydrogens (OBAtom *)
bool | DeleteNonPolarHydrogens ()
bool | DeleteHydrogen (OBAtom *)
bool | AddHydrogens (bool polaronly=false, bool correctForPH=false, double pH=7.4)
bool | AddHydrogens (OBAtom *)
bool | AddPolarHydrogens ()
bool | StripSalts (int threshold=0)
std::vector< OBMol > | Separate (int StartIndex=1)
bool | GetNextFragment (OpenBabel::OBMolAtomDFSIter &iter, OBMol &newMol)
bool | ConvertDativeBonds ()
bool | CorrectForPH (double pH=7.4)
bool | AssignSpinMultiplicity (bool NoImplicitH=false)
void | SetIsPatternStructure ()
vector3 | Center (int nconf)
void | SetTorsion (OBAtom *, OBAtom *, OBAtom *, OBAtom *, double ang)
static const char * | ClassDescription ()

## Detailed Description

Molecule Class.

The most important class in Open Babel is OBMol, or the molecule class. The OBMol class is designed to store all the basic information associated with a molecule, to make manipulations on the connection table of a molecule facile, and to provide member functions which automatically perceive information about a molecule. A guided tour of the OBMol class is a good place to start.

An OBMol class can be declared:

          OBMol mol;

For example:

          #include <iostream.h>

          #include <openbabel/mol.h>
          #include <openbabel/obconversion.h>
          int main(int argc,char **argv)
          {
          OBConversion conv(&cin,&cout);
          if(conv.SetInAndOutFormats("SDF","MOL2"))
          {
          OBMol mol;
          if(conv.Read(&mol))
          ...manipulate molecule

          conv->Write(&mol);
          }
          return(1);
          }

will read in a molecule in SD file format from stdin (or the C++ equivalent cin) and write a MOL2 format file out to standard out. Additionally, The input and output formats can be altered using the OBConversion class

Once a molecule has been read into an OBMol (or created via other methods) the atoms and bonds can be accessed by the following methods:

          OBAtom *atom;
          atom = mol.GetAtom(5); //random access of an atom

or

          OBBond *bond;
          bond = mol.GetBond(14); //random access of a bond

or

          FOR_ATOMS_OF_MOL(atom, mol) // iterator access (see OBMolAtomIter)

or

          FOR_BONDS_OF_MOL(bond, mol) // iterator access (see OBMolBondIter)

It is important to note that atom arrays currently begin at 1 and bond arrays begin at 0. Requesting atom 0 (

          OBAtom *atom = mol.GetAtom(0);

will result in an error, but

          OBBond *bond = mol.GetBond(0);

is perfectly valid. Note that this is expected to change in the near future to simplify coding and improve efficiency.

The ambiguity of numbering issues and off-by-one errors led to the use of iterators in Open Babel. An iterator is essentially just a pointer, but when used in conjunction with Standard Template Library (STL) vectors it provides an unambiguous way to loop over arrays. OBMols store their atom and bond information in STL vectors. Since vectors are template based, a vector of any user defined type can be declared. OBMols declare vector<OBAtom*> and vector<OBBond*> to store atom and bond information. Iterators are then a natural way to loop over the vectors of atoms and bonds.

A variety of predefined iterators have been created to simplify common looping requests (e.g., looping over all atoms in a molecule, bonds to a given atom, etc.)

          #include <openbabel/obiter.h>
          ...
          #define FOR_ATOMS_OF_MOL(a,m)     for( OBMolAtomIter     a(m); a; ++a )
          #define FOR_BONDS_OF_MOL(b,m)     for( OBMolBondIter     b(m); b; ++b )
          #define FOR_NBORS_OF_ATOM(a,p)    for( OBAtomAtomIter    a(p); a; ++a )
          #define FOR_BONDS_OF_ATOM(b,p)    for( OBAtomBondIter    b(p); b; ++b )
          #define FOR_RESIDUES_OF_MOL(r,m)  for( OBResidueIter     r(m); r; ++r )
          #define FOR_ATOMS_OF_RESIDUE(a,r) for( OBResidueAtomIter a(r); a; ++a )
          ...

These convenience functions can be used like so:

          #include <openbabel/obiter.h>
          #include <openbabel/mol.h>

          OBMol mol;
          double exactMass = 0.0;
          FOR_ATOMS_OF_MOL(a, mol)
          {
          exactMass +=  a->GetExactMass();
          }

Note that with these convenience macros, the iterator "a" (or whichever name you pick) is declared for you -- you do not need to do it beforehand.

Examples:

  obconformersearch_default.cpp, obconversion_readstring.cpp, and obforcefield_energy.cpp.

## Constructor & Destructor Documentation

OBMol | ( | ) |

Constructor.

OBMol | ( | const OBMol & | mol ) |

Copy constructor, copies atoms,bonds and OBGenericData.

~OBMol | ( | ) | `[virtual]`

Destructor.

## Member Function Documentation

bool HasFlag | ( | int | flag ) | `[inline, protected]`

Referenced by OBMol::operator=().

void SetFlag | ( | int | flag ) | `[inline, protected]`

void start_kekulize | ( | std::vector< OBAtom * > & | cycle,
|  | std::vector< int > & | electron
| ) |  | `[protected]`

Find a consistent assignment of single/double bonds to a Kekule' ring or a set of fused aromatic rings.

The initial electronic state indicates whether each atom can make a double bond or not. The function works recursively to "walk" around the ring or rings and try all possible arrangements of single and double bonds.

Deprecated:
  Will no longer be a public, visible method

bool expand_kekulize | ( | int | bond_idx,
|  | std::vector< int > & | atomState,
|  | std::vector< int > & | bondState
| ) |  | `[protected]`

Recursively assign single and double bonds according to the electronical state of the atoms.

Deprecated:
  Will no longer be a public, visible method

bool has_no_leftover_electrons | ( | std::vector< int > & | atomState ) | `[protected]`

Check for leftover electrons. This is used during expand_kekulize() to make sure all of the 4n+2 electrons that were available for bonding in the aromatic ring system were actually used during the assignment of single and double bonds.

Deprecated:
  Will no longer be a public, visible method

int getorden | ( | OBAtom * | atom ) | `[protected]`

Give the priority to give two electrons instead of 1

Deprecated:
  Will no longer be a public, visible method

bool expandcycle | ( | OBAtom * | atom,
|  | OBBitVec & | avisit,
|  | const OBBitVec & | potAromBonds
| ) |  | `[protected]`

Recursively find the aromatic atoms with an aromatic bond to the current atom

Deprecated:
  Will no longer be a public, visible method

OBMol & operator= | ( | const OBMol & | mol ) |

Assignment, copies atoms,bonds and OBGenericData.

OBMol & operator+= | ( | const OBMol & | mol ) |

Copies atoms and bonds but not OBGenericData.

void ReserveAtoms | ( | int | natoms ) | `[inline]`

Reserve a minimum number of atoms for internal storage This improves performance since the internal atom vector does not grow.

OBAtom * CreateAtom | ( | void | ) | `[virtual]`

Create a new OBAtom pointer. Does no bookkeeping

Deprecated:
  Use NewAtom instead, which ensures internal connections

OBBond * CreateBond | ( | void | ) | `[virtual]`

Create a new OBBond pointer. Does no bookkeeping

Deprecated:
  Use NewBond instead, which ensures internal connections

OBResidue * CreateResidue | ( | void | ) | `[virtual]`

Create a new OBResidue pointer. Does no bookkeeping

Deprecated:
  Use NewResidue instead, which ensures internal connections

void DestroyAtom | ( | OBAtom * | atom ) | `[virtual]`

Free an OBAtom pointer if defined. Does no bookkeeping

See also:
  DeleteAtom which ensures internal connections

Referenced by OBMol::~OBMol().

void DestroyBond | ( | OBBond * | bond ) | `[virtual]`

Free an OBBond pointer if defined. Does no bookkeeping

See also:
  DeleteBond which ensures internal connections

Referenced by OBMol::~OBMol().

void DestroyResidue | ( | OBResidue * | residue ) | `[virtual]`

Free an OBResidue pointer if defined. Does no bookkeeping

See also:
  DeleteResidue which ensures internal connections

Referenced by OBMol::~OBMol().

bool AddAtom | ( | OBAtom & | atom ) |

Add an atom to a molecule.

Add the specified atom to this molecule

Returns:
  Whether the method was successful

Also checks bond_queue for any bonds that should be made to the new atom

Referenced by OpenBabel::addFragment(), and OBMol::GetNextFragment().

bool InsertAtom | ( | OBAtom & | atom ) |

Add a new atom to this molecule (like AddAtom) Calls BeginModify() before insertion and EndModify() after insertion

bool AddBond | ( | int | beginIdx,
|  | int | endIdx,
|  | int | order,
|  | int | flags = `0`,
|  | int | insertpos = `-1`
| ) |  |

Add a new bond to the molecule with the specified parameters

Parameters:

  beginIdx | the atom index of the "start" atom
  endIdx | the atom index of the "end" atom
  order | the bond order (see OBBond::GetBO())
  flags | any bond flags such as stereochemistry (default = none)
  insertpos | the position index to insert the bond (default = none)

Returns:
  Whether the new bond creation was successful

Referenced by OpenBabel::addFragment(), OBResidueData::AssignBonds(), OBBuilder::Build(), OBMol::ConnectTheDots(), OBMol::GetNextFragment(), OBAtom::HtoMethyl(), and OBAtom::SetHybAndGeom().

bool AddBond | ( | OBBond & | bond ) |

Add the specified residue to this molecule and update connections

Returns:
  Whether the method was successful

bool AddResidue | ( | OBResidue & | residue ) |

Add the specified residue to this molecule and update connections

Returns:
  Whether the method was successful

OBAtom * NewAtom | ( | ) |

Create a new OBAtom in this molecule and ensure connections (e.g. OBAtom::GetParent(). A new unique id will be assigned to this atom.

Referenced by OBUnitCell::FillUnitCell(), OBAtom::HtoMethyl(), and OBAtom::SetHybAndGeom().

OBAtom * NewAtom | ( | unsigned long | id ) |

Instantiate a New Atom and add it to the molecule.

Create a new OBAtom in this molecule and ensure connections. (e.g. OBAtom::GetParent(). The `id` will be assigned to this atom.

Checks bond_queue for any bonds that should be made to the new atom and updates atom indexes.

OBBond * NewBond | ( | ) |

Create a new OBBond in this molecule and ensure connections (e.g. OBBond::GetParent(). A new unique id will be assigned to this bond.

Referenced by OBBuilder::Connect().

OBBond * NewBond | ( | unsigned long | id ) |

Instantiate a New Bond and add it to the molecule.

Create a new OBBond in this molecule and ensure connections (e.g. OBBond::GetParent(). The `id` will be assigned to this bond.

Since:
  version 2.1 Sets the proper Bond index and insures this molecule is set as the parent.

OBResidue * NewResidue | ( | ) |

Create a new OBResidue in this molecule and ensure connections.

bool DeleteAtom | ( | OBAtom * | atom,
|  | bool | destroyAtom = `true`
| ) |  |

Deletes an atom from this molecule and all appropriate bonds. Updates the molecule and atom and bond indexes accordingly.

Warning:
  Does not update any residues which may contain this atom

Returns:
  Whether deletion was successful

Referenced by OBChemTsfm::Apply(), OpenBabel::InternalToCartesian(), and OBAtom::SetHybAndGeom().

bool DeleteBond | ( | OBBond * | bond,
|  | bool | destroyBond = `true`
| ) |  |

Deletes an bond from this molecule and updates accordingly

Returns:
  Whether deletion was successful

Referenced by OBBuilder::Build(), OBMol::ConnectTheDots(), OBBuilder::IsSpiroAtom(), and OBBuilder::Swap().

bool DeleteResidue | ( | OBResidue * | residue,
|  | bool | destroyResidue = `true`
| ) |  |

Deletes a residue from this molecule and updates accordingly.

Returns:
  Whether deletion was successful

void BeginModify | ( | void | ) | `[virtual]`

Call when making many modifications -- clears conformer/rotomer data. The method "turns off" perception routines, improving performance. Changes in molecular structure will be re-considered after modifications.

Referenced by OBAtom::HtoMethyl(), and OBAtom::SetHybAndGeom().

void EndModify | ( | bool | nukePerceivedData = `true` ) | `[virtual]`

Call when done with modificaions -- re-perceive data as needed. This method "turns on" perception routines and re-evaluates molecular structure.

Referenced by OpenBabel::addFragment(), OBAtom::HtoMethyl(), and OBAtom::SetHybAndGeom().

int GetMod | ( | ) | `[inline]`

Returns:
  The number of nested BeginModify() calls. Used internally.

void IncrementMod | ( | ) | `[inline]`

Increase the number of nested BeginModify calls. Dangerous! Instead, properly use BeginModify as needed.

Referenced by OBAtom::SetHybAndGeom().

void DecrementMod | ( | ) | `[inline]`

Decrease the number of nested BeginModify calls. Dangerous! Instead, properly use EndModify as needed.

Referenced by OBAtom::SetHybAndGeom().

int GetFlags | ( | ) | `[inline]`

Returns:
  the entire set of flags. (Internal use, mainly.)

Referenced by OBAtomTyper::AssignImplicitValence().

const char * GetTitle | ( | bool | replaceNewlines = `true` ) | const`[virtual]`

Returns:
  the title of this molecule (often the filename)

Parameters:

  replaceNewlines | whether to replace any newline characters with spaces

Reimplemented from OBBase.

Referenced by OBBuilder::CorrectStereoAtoms(), OBMoleculeFormat::DeferMolOutput(), OBMoleculeFormat::MakeCombinedMolecule(), OBMol::operator+=(), OBMol::operator=(), OBMoleculeFormat::ReadChemObjectImpl(), OBMoleculeFormat::ReadNameIndex(), OBMoleculeFormat::WriteChemObjectImpl(), and OpenBabel::WriteTitles().

unsigned int NumAtoms | ( | ) | const`[inline]`

Returns:
  the number of atoms (i.e. OBAtom children)

Referenced by OBRingSearch::AddRingFromClosure(), OpenBabel::alternate(), OBChemTsfm::Apply(), patty::assign_types(), OBAromaticTyper::AssignAromaticFlags(), OBGastChrg::AssignPartialCharges(), OBRotorList::AssignTorVals(), OpenBabel::CalcSignedVolume(), OpenBabel::CartesianToInternal(), OBMol::Center(), OpenBabel::CompileMoleculeQuery(), OBBuilder::Connect(), OBMol::ConnectTheDots(), OpenBabel::construct_c_matrix(), OpenBabel::construct_g_matrix(), OBMol::CopyConformer(), OBRotamerList::CreateConformerList(), OpenBabel::DetermineFRJ(), OBDepict::DrawMolecule(), OBSmartsMatcher::FastSingleMatch(), OBChargeModel::FillChargeVectors(), OpenBabel::FindAutomorphisms(), OBRotorList::FindRotors(), OpenBabel::generateDiagram(), OBForceField::GetAtomTypes(), OpenBabel::GetChirality(), OBForceField::GetConformers(), OBForceField::GetCoordinates(), OpenBabel::GetDFFVector(), OBAtom::GetNextAtom(), OBMol::GetNextFragment(), OBForceField::GetPartialCharges(), OBSpectrophore::GetSpectrophore(), OpenBabel::GraphPotentials(), OBAtom::HtoMethyl(), OBBond::IsClosure(), OBStericConformerFilter::IsGood(), OBForceField::IsSetupNeeded(), OBMoleculeFormat::MakeCombinedMolecule(), OpenBabel::MinimumPairRMS(), OBMolAtomBFSIter::OBMolAtomBFSIter(), OBMolAtomDFSIter::OBMolAtomDFSIter(), OBSSMatch::OBSSMatch(), OBMol::operator=(), OBMoleculeFormat::ReadChemObjectImpl(), OBRotorList::RemoveSymVals(), OBMol::RenumberAtoms(), OBMol::Rotate(), OBEnergyConformerScore::Score(), OBRMSDConformerScore::Score(), OBAromaticTyper::SelectRootAtoms(), OBMol::Separate(), OBRotamerList::SetBaseCoordinateSets(), OBForceField::SetConformers(), OBMol::SetCoordinates(), OBForceField::SetCoordinates(), OBAlign::SetRefMol(), OBRotorList::SetRotAtoms(), OBAlign::SetTargetMol(), OBProxGrid::Setup(), OBForceField::Setup(), OBSmartsMatcher::SetupAtomMatchTable(), OBMol::Translate(), OBAlign::UpdateCoords(), OpenBabel::visitRing(), and OBMoleculeFormat::WriteChemObjectImpl().

unsigned int NumBonds | ( | ) | const`[inline]`

Returns:
  the number of bonds (i.e. OBBond children)

Referenced by OpenBabel::alternate(), OBBuilder::Build(), OpenBabel::DetermineFRJ(), OBDepict::DrawMolecule(), OpenBabel::get_bonds_of_ring(), OBForceField::IsSetupNeeded(), OBMoleculeFormat::MakeCombinedMolecule(), OBMolBondBFSIter::OBMolBondBFSIter(), OBMol::operator=(), and OpenBabel::visitRing().

unsigned int NumHvyAtoms | ( | ) |

Returns:
  the number of non-hydrogen atoms

unsigned int NumResidues | ( | ) | const`[inline]`

Returns:
  the number of residues (i.e. OBResidue substituents)

Referenced by OBMol::operator=().

unsigned int NumRotors | ( | ) |

Returns:
  the number of rotatble bonds. See OBBond::IsRotor() for details

OBAtom * GetAtom | ( | int | idx ) | const

Returns:
  the atom at index `idx` or NULL if it does not exist.

Warning:
  Atom indexing will change. Use iterator methods instead.

Returns a pointer to the atom after a safety check 0 < idx <= NumAtoms

Referenced by OpenBabel::alternate(), OBChemTsfm::Apply(), OpenBabel::ApplyRotMatToBond(), OBBondTyper::AssignFunctionalGroupBonds(), OBAtomTyper::AssignHyb(), OBAtomTyper::AssignImplicitValence(), OBPhModel::AssignSeedPartialCharge(), OBRingTyper::AssignTypes(), OBAtomTyper::AssignTypes(), OBBuilder::Build(), OpenBabel::BuildOBRTreeVector(), OpenBabel::CalcSignedVolume(), OpenBabel::CartesianToInternal(), OBBuilder::Connect(), OBMol::ConnectTheDots(), OpenBabel::CorrectBadResonanceForm(), OBBuilder::CorrectStereoAtoms(), OBDepict::DrawMolecule(), AliasData::Expand(), OBSmartsMatcher::FastSingleMatch(), OpenBabel::FindAutomorphisms(), OBRing::findCenterAndNormal(), OpenBabel::FindRings(), OpenBabel::generateDiagram(), OpenBabel::get_bonds_of_ring(), OBAtom::GetAngle(), OBForceField::GetAtomTypes(), OBForceField::GetCoordinates(), OpenBabel::GetDFFVector(), OBAtom::GetDistance(), OBAtom::GetNextAtom(), OBMol::GetNextFragment(), OBForceField::GetPartialCharges(), OBRing::GetRootAtom(), OBRotorRules::GetRotorIncrements(), OpenBabel::groupRedraw(), OBRing::IsAromatic(), OBStericConformerFilter::IsGood(), OBForceField::IsSetupNeeded(), OBBuilder::IsSpiroAtom(), OBSmartsMatcher::match(), OBAtom::MatchesSMARTS(), OpenBabel::MinimumPairRMS(), OBMolAtomBFSIter::operator++(), OBMolAtomDFSIter::operator++(), OBMol::PerceiveBondOrders(), OpenBabel::potentialAromaticBonds(), OBMol::RenumberAtoms(), OBAromaticTyper::SelectRootAtoms(), OBRotorList::SetEvalAtoms(), OBBond::SetLength(), OBAlign::SetRefMol(), OBAlign::SetTargetMol(), OBRotamerList::Setup(), OBFFConstraints::Setup(), and OBBuilder::Swap().

OBAtom * GetAtomById | ( | unsigned long | id ) | const

Returns:
  the atom with `id` or NULL if it does not exist.

Referenced by OpenBabel::CanonicalLabels(), OBBuilder::CorrectStereoAtoms(), OBBuilder::CorrectStereoBonds(), and OBBuilder::IsSpiroAtom().

OBAtom * GetFirstAtom | ( | ) | const

Returns:
  the first atom in this molecule, or NULL if none exist.

Deprecated:
  Will be removed in favor of more standard iterator methods

OBBond * GetBond | ( | int | idx ) | const

Returns:
  the bond at index `idx` or NULL if it does not exist.

Warning:
  Bond indexing may change. Use iterator methods instead.

Returns a pointer to the bond after a safety check 0 <= idx < NumBonds

Referenced by OpenBabel::addNbrs(), OpenBabel::alternate(), OBChemTsfm::Apply(), OpenBabel::atomRingToBondRing(), OBBuilder::Build(), OpenBabel::CanonicalLabels(), OBBuilder::CorrectStereoAtoms(), OBBuilder::CorrectStereoBonds(), OBDepict::DrawMolecule(), OpenBabel::expandKekulize(), OBSmartsMatcher::FastSingleMatch(), OpenBabel::findMetalloceneBonds(), OpenBabel::FindRings(), OBMolBondBFSIter::operator++(), OBMol::PerceiveBondOrders(), OpenBabel::potentialAromaticBonds(), and OBBuilder::Swap().

OBBond * GetBondById | ( | unsigned long | id ) | const

Returns:
  the bond with `id` or NULL if it does not exist.

OBBond * GetBond | ( | int | a,
|  | int | b
| ) |  | const

Returns:
  the bond connecting the atom indexed by `a` and `b` or NULL if none exists.

Warning:
  Atom indexing will change. Use atom objects and iterators instead.

OBBond * GetBond | ( | OBAtom * | bgn,
|  | OBAtom * | end
| ) |  | const

Returns:
  the bond between the atoms `bgn` and `end` or NULL if none exists

OBResidue * GetResidue | ( | int | idx ) | const

Returns:
  the residue indexed by `idx`, or NULL if none exists

Warning:
  Residue indexing may change. Use iterator methods instead.

Referenced by OBMol::operator=().

std::vector< OBInternalCoord * > GetInternalCoord | ( | ) |

double GetTorsion | ( | int | a,
|  | int | b,
|  | int | c,
|  | int | d
| ) |  |

Returns:
  the dihedral angle (in degrees) between the four atoms supplied a1-a2-a3-a4) WARNING: SetTorsion takes an angle in radians while GetTorsion returns it in degrees

Referenced by OBBuilder::CorrectStereoBonds(), OBRotorRules::GetRotorIncrements(), and OBMol::PerceiveBondOrders().

double GetTorsion | ( | OBAtom * | a,
|  | OBAtom * | b,
|  | OBAtom * | c,
|  | OBAtom * | d
| ) |  |

Returns:
  the dihedral angle (in degrees) between the four atoms `a`, `b`, `c`, and `d`) WARNING: SetTorsion takes an angle in radians while GetTorsion returns it in degrees

double GetAngle | ( | OBAtom * | a,
|  | OBAtom * | b,
|  | OBAtom * | c
| ) |  |

Returns:
  the angle (in degrees) between the three atoms `a`, `b` and `c` (where a-> b (vertex) -> c )

string GetFormula | ( | ) |

Returns:
  the stochoimetric formula (e.g., C4H6O)

Stochoimetric formula (e.g., C4H6O). This is either set by OBMol::SetFormula() or generated on-the-fly using the "Hill order" -- i.e., C first if present, then H if present all other elements in alphabetical order.

string GetSpacedFormula | ( | int | ones = `0`,
|  | const char * | sp = `" "`,
|  | bool | implicitH = `true`
| ) |  |

Returns:
  the stochoimetric formula in spaced format e.g. C 4 H 6 O 1

Stochoimetric formula in spaced format e.g. C 4 H 6 O 1 No pair data is stored. Normally use without parameters: GetSpacedFormula()

Since:
  version 2.1

Referenced by OBMoleculeFormat::MakeCombinedMolecule().

double GetEnergy | ( | ) | const`[inline]`

Returns:
  the heat of formation for this molecule (in kcal/mol)

Referenced by OBMol::operator=().

double GetMolWt | ( | bool | implicitH = `true` ) |

Returns:
  the standard molar mass given by IUPAC atomic masses (amu)

double GetExactMass | ( | bool | implicitH = `true` ) |

Returns:
  the mass given by isotopes (or most abundant isotope, if not specified)

int GetTotalCharge | ( | ) |

Returns:
  the total charge on this molecule (i.e., 0 = neutral, +1, -1...)

Returns the total molecular charge -- if it has not previously been set it is calculated from the atomic formal charge information. (This may or may not be correct!) If you set atomic charges with OBAtom::SetFormalCharge() you really should set the molecular charge with OBMol::SetTotalCharge()

Referenced by OBMol::operator=().

unsigned int GetTotalSpinMultiplicity | ( | ) |

Returns:
  the total spin on this molecule (i.e., 1 = singlet, 2 = doublet...)

Returns the total spin multiplicity -- if it has not previously been set It is calculated from the atomic spin multiplicity information assuming the high-spin case (i.e. it simply sums the number of unpaired electrons assuming no further pairing of spins.

Referenced by OBMol::operator=().

unsigned short int GetDimension | ( | ) | const`[inline]`

Returns:
  the dimensionality of coordinates (i.e., 0 = unknown or no coord, 2=2D, 3=3D)

Referenced by OBBuilder::Build(), OpenBabel::CanonicalLabels(), OBPhModel::CorrectForPH(), OBMol::GetNextFragment(), OBMoleculeFormat::MakeCombinedMolecule(), OBMol::operator+=(), and OBMol::operator=().

double* GetCoordinates | ( | ) | `[inline]`

Returns:
  the set of all atomic coordinates. See OBAtom::GetCoordPtr for more

Referenced by OBScoreGrid::Eval(), OBRotorList::RemoveSymVals(), OBEnergyConformerScore::Score(), OBRotamerList::SetCurrentCoordinates(), OBProxGrid::Setup(), and OBConformerSearch::Setup().

vector< OBRing * > & GetSSSR | ( | ) |

Implements blue-obelisk:findSmallestSetOfSmallestRings.

Returns:
  the Smallest Set of Smallest Rings has been run (see OBRing class)

Referenced by OBRingTyper::AssignTypes(), OBDepict::DrawMolecule(), OBBond::FindSmallestRing(), OBAtom::IsInRingSize(), OBAtom::MemberOfRingCount(), OBAtom::MemberOfRingSize(), OBMol::PerceiveBondOrders(), and OBAromaticTyper::SelectRootAtoms().

vector< OBRing * > & GetLSSR | ( | ) |

Returns:
  the Largest Set of Smallest Rings has been run (see OBRing class)

Referenced by OpenBabel::potentialAromaticBonds().

bool AutomaticFormalCharge | ( | ) | `[inline]`

Get the current flag for whether formal charges are set with pH correction.

Referenced by OBPhModel::CorrectForPH().

bool AutomaticPartialCharge | ( | ) | `[inline]`

Get the current flag for whether partial charges are auto-determined.

Referenced by OBPhModel::AssignSeedPartialCharge().

void SetTitle | ( | const char * | title ) | `[virtual]`

Set the title of this molecule to `title`.

Reimplemented from OBBase.

Referenced by OBMoleculeFormat::MakeCombinedMolecule().

void SetTitle | ( | std::string & | title ) |

Set the title of this molecule to `title`.

void SetFormula | ( | std::string | molFormula ) |

Set the stochiometric formula for this molecule.

void SetEnergy | ( | double | energy ) | `[inline]`

Set the heat of formation for this molecule (in kcal/mol)

void SetDimension | ( | unsigned short int | d ) | `[inline]`

Set the dimension of this molecule (i.e., 0, 1 , 2, 3)

Referenced by OBBuilder::Build(), and OBMol::GetNextFragment().

void SetTotalCharge | ( | int | charge ) |

Set the total charge of this molecule to `charge`.

void SetTotalSpinMultiplicity | ( | unsigned int | spinMultiplicity ) |

Set the total spin multiplicity of this molecule to `spinMultiplicity` Overrides the calculation from spin multiplicity of OBAtoms

void SetInternalCoord | ( | std::vector< OBInternalCoord * > | int_coord ) | `[inline]`

Set the internal coordinates to `int_coord` (Does not call InternalToCartesian to update the 3D cartesian coordinates)

void SetAutomaticFormalCharge | ( | bool | val ) | `[inline]`

Set the flag for determining automatic formal charges with pH (default=true)

void SetAutomaticPartialCharge | ( | bool | val ) | `[inline]`

Set the flag for determining partial charges automatically (default=true)

void SetAromaticPerceived | ( | ) | `[inline]`

Mark that aromaticity has been perceived for this molecule (see OBAromaticTyper)

Referenced by OBAromaticTyper::AssignAromaticFlags(), and OBAtomTyper::AssignImplicitValence().

void SetSSSRPerceived | ( | ) | `[inline]`

Mark that Smallest Set of Smallest Rings has been run (see OBRing class)

void SetLSSRPerceived | ( | ) | `[inline]`

Mark that Largest Set of Smallest Rings has been run (see OBRing class)

void SetRingAtomsAndBondsPerceived | ( | ) | `[inline]`

Mark that rings have been perceived (see OBRing class for details)

void SetAtomTypesPerceived | ( | ) | `[inline]`

Mark that atom types have been perceived (see OBAtomTyper for details)

Referenced by OBAtomTyper::AssignTypes().

void SetRingTypesPerceived | ( | ) | `[inline]`

Mark that ring types have been perceived (see OBRingTyper for details)

Referenced by OBRingTyper::AssignTypes().

void SetChainsPerceived | ( | ) | `[inline]`

Mark that chains and residues have been perceived (see OBChainsParser)

void SetChiralityPerceived | ( | ) | `[inline]`

Mark that chirality has been perceived.

void SetPartialChargesPerceived | ( | ) | `[inline]`

Mark that partial charges have been assigned.

Referenced by OBPhModel::AssignSeedPartialCharge().

void SetHybridizationPerceived | ( | ) | `[inline]`

Mark that hybridization of all atoms has been assigned.

Referenced by OBAtomTyper::AssignHyb(), OBBuilder::Build(), and OBMol::PerceiveBondOrders().

void SetImplicitValencePerceived | ( | ) | `[inline]`

Mark that the implicit hydrogen valence of all atoms has been assigned.

Referenced by OBAtomTyper::AssignImplicitValence().

void SetKekulePerceived | ( | ) | `[inline]`

Mark that Kekule forms have been assigned by Kekulize()

void SetClosureBondsPerceived | ( | ) | `[inline]`

Mark that ring closure bonds have been assigned by graph traversal.

Referenced by OBBond::IsClosure().

void SetHydrogensAdded | ( | ) | `[inline]`

Mark that explicit hydrogen atoms have been added.

void SetCorrectedForPH | ( | ) | `[inline]`

Referenced by OBPhModel::CorrectForPH().

void SetAromaticCorrected | ( | ) | `[inline]`

Referenced by OBAtomTyper::CorrectAromaticNitrogens().

void SetSpinMultiplicityAssigned | ( | ) | `[inline]`

void SetFlags | ( | int | flags ) | `[inline]`

Referenced by OBAtomTyper::AssignImplicitValence().

void UnsetAromaticPerceived | ( | ) | `[inline]`

void UnsetSSSRPerceived | ( | ) | `[inline]`

void UnsetRingTypesPerceived | ( | ) | `[inline]`

void UnsetPartialChargesPerceived | ( | ) | `[inline]`

void UnsetImplicitValencePerceived | ( | ) | `[inline]`

Referenced by OBChemTsfm::Apply().

void UnsetHydrogensAdded | ( | ) | `[inline]`

void UnsetFlag | ( | int | flag ) | `[inline]`

Referenced by OBMol::RenumberAtoms().

OBBase * DoTransformations | ( | const std::map< std::string, std::string > * | ,
|  | OBConversion * |
| ) |  | `[virtual]`

Perform a set of transformations specified by the user

Typically these are program options to filter or modify an object For example, see OBMol::DoTransformations() and OBMol::ClassDescription() Base type does nothing

Reimplemented from OBBase.

Referenced by OBMoleculeFormat::ReadChemObjectImpl().

const char * ClassDescription | ( | ) | `[static]`

Returns:
  A list of descriptions of command-line options for DoTransformations()

Reimplemented from OBBase.

bool Clear | ( | void | ) | `[virtual]`

Clear all information from a molecule except OB_PATTERN_STRUCTURE left unchanged.

Reimplemented from OBBase.

Referenced by OpenBabel::addFragment(), OBMoleculeFormat::ReadNameIndex(), OBMol::Separate(), and OBAlign::SetRefMol().

void RenumberAtoms | ( | std::vector< OBAtom * > & | v ) |

Renumber the atoms of this molecule according to the order in the supplied vector.

Renumber the atoms in this molecule according to the order in the supplied vector. This will return without action if the supplied vector is empty or does not have the same number of atoms as the molecule.

Referenced by OBMol::RenumberAtoms().

void RenumberAtoms | ( | std::vector< int > | v ) |

Renumber the atoms of this molecule using the initial indexes in the supplied vector.

Renumber the atoms according to the order of indexes in the supplied vector This with assemble an atom vector and call RenumberAtoms(vector<OBAtom*>) It will return without action if the supplied vector is empty or does not have the same number of atoms as the molecule.

Since:
  version 2.3

void SetCoordinates | ( | double * | c ) |

Set the coordinates for all atoms in this conformer.

See also:
  OBMol::GetCoordinates()

void ToInertialFrame | ( | int | conf,
|  | double * | rmat
| ) |  |

Translate one conformer and rotate by a rotation matrix (which is returned) to the inertial frame-of-reference.

void ToInertialFrame | ( | ) |

Translate all conformers to the inertial frame-of-reference.

void Translate | ( | const vector3 & | v ) |

Translates all conformers in the molecule by the supplied vector.

this method adds the vector v to all atom positions in all conformers

void Translate | ( | const vector3 & | v,
|  | int | nconf
| ) |  |

Translates one conformer in the molecule by the supplied vector.

this method adds the vector v to all atom positions in the conformer nconf. If nconf == OB_CURRENT_CONFORMER, then the atom positions in the current conformer are translated.

void Rotate | ( | const double | u[3][3] ) |

Rotate all conformers using the supplied matrix `u` (a 3x3 array of double)

Referenced by OBMol::Rotate().

void Rotate | ( | const double | m[9] ) |

Rotate all conformers using the supplied matrix `m` (a linear 3x3 row-major array of double)

void Rotate | ( | const double | m[9],
|  | int | nconf
| ) |  |

Rotate a specific conformer `nconf` using the supplied rotation matrix `m`.

void Center | ( | ) |

Translate to the center of all coordinates (for this conformer)

bool Kekulize | ( | ) |

Transform to standard Kekule bond structure (presumably from an aromatic form)

Referenced by OBMol::PerceiveBondOrders().

bool PerceiveKekuleBonds | ( | ) |

void NewPerceiveKekuleBonds | ( | ) |

Kekulize aromatic rings without using implicit valence.

This new perceive kekule bonds function has been designed to handle molecule files without explicit hydrogens such as pdb or xyz. (It can, of course, easily handle explicit hydrogens too.) The function does not rely on GetImplicitValence function The function looks for groups of aromatic cycle For each group it tries to guess the number of electrons given by each atom in order to satisfy the huckel (4n+2) rule If the huckel rule cannot be satisfied the algorithm try with its best alternative guess Then it recursively walk on the atoms of the cycle and assign single and double bonds

Deprecated:
  Will no longer be a public, visible method

bool DeleteHydrogens | ( | ) |

Delete all hydrogens from the molecule

Returns:
  Success

Referenced by OBPhModel::CorrectForPH().

bool DeleteHydrogens | ( | OBAtom * | atom ) |

Delete all hydrogens from the supplied atom

Returns:
  Success

bool DeleteNonPolarHydrogens | ( | ) |

Delete all hydrogen atoms connected to a non-polar atom

See also:
  OBAtom::IsNonPolarHydrogen

bool DeleteHydrogen | ( | OBAtom * | atom ) |

Delete the supplied atom if it is a hydrogen (Helper function for DeleteHydrogens)

bool AddHydrogens | ( | bool | polaronly = `false`,
|  | bool | correctForPH = `false`,
|  | double | pH = `7.4`
| ) |  |

Add hydrogens to the entire molecule to fill out implicit valence spots

Parameters:

  polaronly | Whether to add hydrogens only to polar atoms (i.e., not to C atoms)
  correctForPH | Whether to call CorrectForPH() first
  pH | The pH to use for CorrectForPH() modification

Returns:
  Whether any hydrogens were added

Referenced by OBSmartsPattern::Match().

bool AddHydrogens | ( | OBAtom * | atom ) |

Add hydrogens only to the supplied atom to fill out implicit valence.

bool AddPolarHydrogens | ( | ) |

Add only polar hydrogens (i.e., attached to polar atoms, not C)

bool StripSalts | ( | int | threshold = `0` ) |

If `threshold` is not specified or is zero, remove all but the largest contiguous fragment. If `threshold` is non-zero, remove any fragments with fewer than `threshold` atoms.

vector< OBMol > Separate | ( | int | StartIndex = `1` ) |

Copies each disconnected fragment as a separate OBMol.

Referenced by OBBuilder::IsSpiroAtom(), and OBMoleculeFormat::ReadChemObjectImpl().

bool GetNextFragment | ( | OpenBabel::OBMolAtomDFSIter & | iter,
|  | OBMol & | newMol
| ) |  |

Iterative component of Separate to copy one fragment at a time.

Referenced by OBMol::Separate().

bool ConvertDativeBonds | ( | ) |

Converts the charged form of coordinate bonds, e.g.[N+]([O-])=O to N(=O)=O.

Converts for instance [N+]([O-])=O to N(=O)=O.

bool CorrectForPH | ( | double | pH = `7.4` ) |

Correct for pH by applying the OBPhModel transformations.

bool AssignSpinMultiplicity | ( | bool | NoImplicitH = `false` ) |

set spin multiplicity for H-deficient atoms

If NoImplicitH is true then the molecule has no implicit hydrogens. Individual atoms on which ForceNoH() has been called also have no implicit hydrogens. If NoImplicitH is false (the default), then if there are any explicit hydrogens on an atom then they constitute all the hydrogen on that atom. However, a hydrogen atom with its _isotope!=0 is not considered explicit hydrogen for this purpose. In addition, an atom which has had ForceImplH()called for it is never considered hydrogen deficient, e.g. unbracketed atoms in SMILES. Any discrepancy with the expected atom valency is interpreted as the atom being a radical of some sort and iits _spinMultiplicity is set to 2 when it is one hydrogen short and 3 when it is two hydrogens short and similarly for greater hydrogen deficiency.

So SMILES C[CH] is interpreted as methyl carbene, CC[H][H] as ethane, and CC[2H] as CH3CH2D.

Referenced by OpenBabel::alternate(), and OBMol::PerceiveBondOrders().

void SetIsPatternStructure | ( | ) | `[inline]`

The OBMol is a pattern, not a complete molecule. Left unchanged by Clear().

vector3 Center | ( | int | nconf ) |

Returns:
  the center of the supplied conformer `nconf`

See also:
  Center() to actually center all conformers at the origin

void SetTorsion | ( | OBAtom * | a,
|  | OBAtom * | b,
|  | OBAtom * | c,
|  | OBAtom * | d,
|  | double | ang
| ) |  |

Set the torsion defined by these atoms, rotating bonded neighbors

ang The torsion angle in radians
  WARNING: SetTorsion takes an angle in radians while GetTorsion returns it in degrees

Referenced by OBBuilder::Connect(), and OBBuilder::CorrectStereoBonds().

void FindSSSR | ( | ) |

Find Smallest Set of Smallest Rings (see OBRing class for more details)

Referenced by OBAtom::IsInRingSize(), OBAtom::MemberOfRingCount(), OBAtom::MemberOfRingSize(), OBMolRingIter::OBMolRingIter(), and OBMol::PerceiveBondOrders().

void FindLSSR | ( | ) |

Find Largest Set of Smallest Rings.

void FindRingAtomsAndBonds | ( | ) |

Find all ring atoms and bonds. Does not need to call FindSSSR().

Referenced by OBRotorList::FindRotors(), OBBond::IsInRing(), and OBAtom::IsInRing().

void FindChiralCenters | ( | ) | `[inline]`

Find all chiral atom centers. See OBAtom::IsChiral() for more details

Deprecated:
  See FindStereogenicUnits

void FindChildren | ( | std::vector< int > & | children,
|  | int | first,
|  | int | second
| ) |  |

locates all atoms for which there exists a path to 'second' without going through 'first' children must not include 'second'

Referenced by OpenBabel::ApplyRotMatToBond(), OBRotorList::AssignTorVals(), OBBond::SetLength(), OBRotorList::SetRotAtoms(), OBRotorList::SetRotAtomsByFix(), and OBRotamerList::Setup().

void FindChildren | ( | std::vector< OBAtom * > & | children,
|  | OBAtom * | bgn,
|  | OBAtom * | end
| ) |  |

locates all atoms for which there exists a path to 'end' without going through 'bgn' children must not include 'end'

void FindLargestFragment | ( | OBBitVec & | frag ) |

Find the largest fragment in OBMol (which may include multiple non-connected fragments)

Parameters:

  frag | Return (by reference) a bit vector indicating the atoms in the largest fragment

void ContigFragList | ( | std::vector< std::vector< int > > & | cfl ) |

Sort a list of contig fragments by size from largest to smallest Each vector<int> contains the atom numbers of a contig fragment

Referenced by OpenBabel::DetermineFRJ().

void Align | ( | OBAtom * | a1,
|  | OBAtom * | a2,
|  | vector3 & | p1,
|  | vector3 & | p2
| ) |  |

Aligns atom a on p1 and atom b along p1->p2 vector.

void ConnectTheDots | ( | void | ) |

Adds single bonds based on atom proximity.

This method adds single bonds between all atoms closer than their combined atomic covalent radii, then "cleans up" making sure bonded atoms are not closer than 0.4A and the atom does not exceed its valence. It implements blue-obelisk:rebondFrom3DCoordinates.

void PerceiveBondOrders | ( | ) |

Attempts to perceive multiple bonds based on geometries.

This method uses bond angles and geometries from current connectivity to guess atom types and then filling empty valences with multiple bonds. It currently has a pass to detect some frequent functional groups. It still needs a pass to detect aromatic rings to "clean up." AssignSpinMultiplicity(true) is called at the end of the function. The true states that there are no implict hydrogens in the molecule.

void FindAngles | ( | ) |

Fills out an OBAngleData with angles from the molecule.

Referenced by OBMolAngleIter::OBMolAngleIter().

void FindTorsions | ( | ) |

Fills out an OBTorsionData with angles from the molecule.

Referenced by OBMolTorsionIter::OBMolTorsionIter().

bool GetGTDVector | ( | std::vector< int > & | gtd ) |

Calculates the graph theoretical distance (GTD) of each atom.

Creates a vector (indexed from zero) containing, for each atom in the molecule, the number of bonds plus one to the most distant non-H atom.

For example, for the molecule H3CC(=O)Cl the GTD value for C1 would be 3, as the most distant non-H atom (either Cl or O) is 2 bonds away.

Since the GTD measures the distance to non-H atoms, the GTD values for terminal H atoms tend to be larger than for non-H terminal atoms. In the example above, the GTD values for the H atoms are all 4.

Referenced by OBRotorList::FindRotors().

void GetGIVector | ( | std::vector< unsigned int > & | vid ) |

Calculates a set of graph invariant indexes using the graph theoretical distance, number of connected heavy atoms, aromatic boolean, ring boolean, atomic number, and summation of bond orders connected to the atom. Vector is indexed from zero.

void GetGIDVector | ( | std::vector< unsigned int > & | vgid ) |

Calculates a set of symmetry identifiers for a molecule. Atoms with the same symmetry ID are symmetrically equivalent. Vector is indexed from zero.

bool Has2D | ( | bool | Not3D = `false` ) |

Are there non-zero coordinates in two dimensions (i.e. X and Y)- and, if Not3D is true, no Z coordinates?

bool Has3D | ( | ) |

Are there non-zero coordinates in all three dimensions (i.e. X, Y, Z)?

Referenced by OpenBabel::CalcSignedVolume().

bool HasNonZeroCoords | ( | ) |

Are there any non-zero coordinates?

bool HasAromaticPerceived | ( | ) | `[inline]`

Has aromatic perception been performed?

Referenced by OBAromaticTyper::AssignAromaticFlags(), OBBond::IsAromatic(), and OBAtom::IsAromatic().

bool HasSSSRPerceived | ( | ) | `[inline]`

Has the smallest set of smallest rings (FindSSSR) been performed?

Referenced by OBAtom::IsInRingSize(), OBAtom::MemberOfRingCount(), OBAtom::MemberOfRingSize(), OBMolRingIter::OBMolRingIter(), and OBMol::PerceiveBondOrders().

bool HasLSSRPerceived | ( | ) | `[inline]`

Has the largest set of smallest rings (FindLSSR) been performed?

bool HasRingAtomsAndBondsPerceived | ( | ) | `[inline]`

Have ring atoms and bonds been assigned?

Referenced by OBBond::IsInRing(), and OBAtom::IsInRing().

bool HasAtomTypesPerceived | ( | ) | `[inline]`

Have atom types been assigned by OBAtomTyper?

Referenced by OBAtom::GetType().

bool HasRingTypesPerceived | ( | ) | `[inline]`

Have ring types been assigned by OBRingTyper?

Referenced by OBRing::GetType().

bool HasChiralityPerceived | ( | ) | `[inline]`

Has atom chirality been assigned?

Referenced by OpenBabel::CanonicalLabels(), and OBMol::operator=().

bool HasPartialChargesPerceived | ( | ) | `[inline]`

Have atomic Gasteiger partial charges been assigned by OBGastChrg?

bool HasHybridizationPerceived | ( | ) | `[inline]`

Has atomic hybridization been assigned by OBAtomTyper?

Referenced by OBAtom::GetHyb().

bool HasImplicitValencePerceived | ( | ) | `[inline]`

Has implicit hydrogen valence been assigned by OBAtomTyper?

Referenced by OBAtomTyper::AssignImplicitValence(), OBAtom::GetImplicitValence(), and OBAtom::ImplicitHydrogenCount().

bool HasKekulePerceived | ( | ) | `[inline]`

Has aromaticity and Kekule forms been assigned by Kekulize?

bool HasClosureBondsPerceived | ( | ) | `[inline]`

Have ring "closure" bonds been assigned? (e.g., OBBond::IsClosure())

Referenced by OBBond::IsClosure().

bool HasChainsPerceived | ( | ) | `[inline]`

Have biomolecule chains and residues been assigned by OBChainsParser?

bool HasHydrogensAdded | ( | ) | `[inline]`

Have hydrogens been added to the molecule?

bool HasAromaticCorrected | ( | ) | `[inline]`

Have aromatic nitrogens been "corrected?" (deprecated)

Referenced by OBAtomTyper::AssignImplicitValence(), and OBAtomTyper::CorrectAromaticNitrogens().

bool IsCorrectedForPH | ( | ) | `[inline]`

Has the molecule been corrected for pH by CorrectForPH?

Referenced by OBPhModel::CorrectForPH().

bool HasSpinMultiplicityAssigned | ( | ) | `[inline]`

Has total spin multiplicity been assigned?

bool IsChiral | ( | ) |

Is this molecule chiral?

bool Empty | ( | ) | `[inline]`

Are there any atoms in this molecule?

Referenced by OBMol::ConnectTheDots(), OBSSMatch::OBSSMatch(), OBMol::PerceiveBondOrders(), and OBMol::RenumberAtoms().

int NumConformers | ( | ) | `[inline]`

Returns:
  the number of conformers in this molecule

Referenced by OBMoleculeFormat::DoOutputOptions(), OBMol::operator=(), OBMol::RenumberAtoms(), OBMol::Rotate(), OBForceField::SetConformers(), and OBMol::Translate().

void SetConformers | ( | std::vector< double * > & | v ) |

Set the entire set of conformers for this molecule to `v`.

Referenced by OBForceField::GetConformers(), and OBConformerSearch::GetConformers().

void AddConformer | ( | double * | f ) | `[inline]`

Add a new set of coordinates `f` as a new conformer.

void SetConformer | ( | int | i ) |

Set the molecule's current conformer to `i` Does nothing if `i` is less than 0 or i is larger than NumConformers()

Referenced by OBMol::Center(), OBMoleculeFormat::DoOutputOptions(), and OBForceField::GetConformers().

void CopyConformer | ( | double * | c,
|  | int | nconf
| ) |  |

Copy the conformer `nconf` into the array `c`

Warning:
  Does no checking to see if `c` is large enough

void DeleteConformer | ( | int | nconf ) |

Delete the conformer `nconf`.

double* GetConformer | ( | int | i ) | `[inline]`

Returns:
  the coordinates to conformer `i`

Referenced by OBMol::operator=(), OBMol::RenumberAtoms(), OBMol::Rotate(), OBForceField::SetConformers(), and OBMol::Translate().

void SetEnergies | ( | std::vector< double > & | energies ) |

Set the entire set of conformer energies.

vector< double > GetEnergies | ( | ) |

Set the entire set of conformer energies.

double GetEnergy | ( | int | ci ) |

Get the energy for conformer ci

ci conformer index

double* BeginConformer | ( | std::vector< double * >::iterator & | i ) | `[inline]`

Set the iterator to the beginning of the conformer list

Returns:
  the array of coordinates for the first conformer

double* NextConformer | ( | std::vector< double * >::iterator & | i ) | `[inline]`

Advance the iterator to the next confomer, if possible

Returns:
  The array of coordinates for the next conformer, or NULL if none exist

std::vector<double*>& GetConformers | ( | ) | `[inline]`

Returns:
  the entire set of conformers for this molecule as a vector of floating point arrays

Referenced by OBRotamerList::SetBaseCoordinateSets().

OBAtomIterator BeginAtoms | ( | ) | `[inline]`

Returns:
  An atom iterator pointing to the beginning of the atom list

OBAtomIterator EndAtoms | ( | ) | `[inline]`

Returns:
  An atom iterator pointing to the end of the atom list

OBBondIterator BeginBonds | ( | ) | `[inline]`

Returns:
  A bond iterator pointing to the beginning of the bond list

OBBondIterator EndBonds | ( | ) | `[inline]`

Returns:
  A bond iterator pointing to the end of the bond list

OBResidueIterator BeginResidues | ( | ) | `[inline]`

Returns:
  A residue iterator pointing to the beginning of the residue list

OBResidueIterator EndResidues | ( | ) | `[inline]`

Returns:
  A residue iterator pointing to the end of the residue list

OBAtom * BeginAtom | ( | OBAtomIterator & | i ) |

Set the iterator `i` to the beginning of the atom list

Returns:
  the first atom (or NULL if none exist)

Referenced by OBAromaticTyper::AssignAromaticFlags(), OBResidueData::AssignBonds(), OBAtomTyper::AssignHyb(), OBAtomTyper::AssignImplicitValence(), OBGastChrg::AssignPartialCharges(), OBAtomTyper::AssignTypes(), OpenBabel::CalcSignedVolume(), OpenBabel::CartesianToInternal(), OBMol::Center(), OBMol::ConnectTheDots(), OpenBabel::construct_c_matrix(), OpenBabel::construct_g_matrix(), OBMol::ConvertDativeBonds(), OBDepict::DrawMolecule(), OBAromaticTyper::ExcludeSmallRing(), OBSmartsMatcher::FastSingleMatch(), OBChargeModel::FillChargeVectors(), OpenBabel::GetChirality(), OpenBabel::GetDFFVector(), OBAtom::GetPartialCharge(), OBMol::Has2D(), OBMol::Has3D(), OBMol::HasNonZeroCoords(), OBGrid::Init(), OpenBabel::InternalToCartesian(), OBMol::IsChiral(), OBBond::IsClosure(), OBMolAtomIter::OBMolAtomIter(), OBMolPairIter::OBMolPairIter(), OBMolPairIter::operator++(), OBMol::operator+=(), OBMol::operator=(), OBMol::PerceiveBondOrders(), OBMol::RenumberAtoms(), OBMol::SetCoordinates(), OBProxGrid::Setup(), OBSmartsMatcher::SetupAtomMatchTable(), and OBMol::~OBMol().

OBAtom * NextAtom | ( | OBAtomIterator & | i ) |

Advance the iterator `i` to the next atom in the molecule

Returns:
  the next atom (if any, or NULL if none exist)

Referenced by OBAromaticTyper::AssignAromaticFlags(), OBResidueData::AssignBonds(), OBAtomTyper::AssignHyb(), OBAtomTyper::AssignImplicitValence(), OBGastChrg::AssignPartialCharges(), OBAtomTyper::AssignTypes(), OpenBabel::CalcSignedVolume(), OpenBabel::CartesianToInternal(), OBMol::Center(), OBMol::ConnectTheDots(), OpenBabel::construct_c_matrix(), OpenBabel::construct_g_matrix(), OBMol::ConvertDativeBonds(), OBDepict::DrawMolecule(), OBAromaticTyper::ExcludeSmallRing(), OBSmartsMatcher::FastSingleMatch(), OBChargeModel::FillChargeVectors(), OpenBabel::GetChirality(), OpenBabel::GetDFFVector(), OBAtom::GetPartialCharge(), OBMol::Has2D(), OBMol::Has3D(), OBMol::HasNonZeroCoords(), OBGrid::Init(), OpenBabel::InternalToCartesian(), OBMol::IsChiral(), OBBond::IsClosure(), OBMolPairIter::OBMolPairIter(), OBMolPairIter::operator++(), OBMol::operator+=(), OBMol::operator=(), OBMol::PerceiveBondOrders(), OBMol::RenumberAtoms(), OBMol::SetCoordinates(), OBProxGrid::Setup(), OBSmartsMatcher::SetupAtomMatchTable(), and OBMol::~OBMol().

OBBond * BeginBond | ( | OBBondIterator & | i ) |

Set the iterator `i` to the beginning of the bond list

Returns:
  the first bond (or NULL if none exist)

Referenced by OBAromaticTyper::AssignAromaticFlags(), OBGastChrg::AssignPartialCharges(), OpenBabel::DetermineFRJ(), OBDepict::DrawMolecule(), OBRotorList::FindRotors(), OBBond::IsClosure(), OBMolBondIter::OBMolBondIter(), OBMol::operator+=(), OBMol::operator=(), OBAromaticTyper::SelectRootAtoms(), and OBMol::~OBMol().

OBBond * NextBond | ( | OBBondIterator & | i ) |

Advance the iterator `i` to the next bond in the molecule

Returns:
  the next bond (if any, or NULL if none exist)

Referenced by OBAromaticTyper::AssignAromaticFlags(), OBGastChrg::AssignPartialCharges(), OpenBabel::DetermineFRJ(), OBDepict::DrawMolecule(), OBRotorList::FindRotors(), OBBond::IsClosure(), OBMolBondIter::operator++(), OBMol::operator+=(), OBMol::operator=(), OBAromaticTyper::SelectRootAtoms(), and OBMol::~OBMol().

OBResidue* BeginResidue | ( | OBResidueIterator & | i ) | `[inline]`

Set the iterator `i` to the beginning of the resdiue list

Returns:
  the first residue (or NULL if none exist)

Referenced by OBResidueIter::OBResidueIter(), OBMol::operator+=(), and OBMol::~OBMol().

OBResidue* NextResidue | ( | OBResidueIterator & | i ) | `[inline]`

Advance the iterator `i` to the next residue in the molecule

Returns:
  the next residue (if any, or NULL if not possible)

Referenced by OBResidueIter::operator++(), OBMol::operator+=(), and OBMol::~OBMol().

OBInternalCoord* BeginInternalCoord | ( | std::vector< OBInternalCoord * >::iterator & | i ) | `[inline]`

Set the iterator to the beginning of the internal coordinate list

Returns:
  the first internal coordinate record, or NULL if none exist

See also:
  SetInternalCoord

OBInternalCoord* NextInternalCoord | ( | std::vector< OBInternalCoord * >::iterator & | i ) | `[inline]`

Advance the iterator to the next internal coordinate record

Returns:
  the next first internal coordinate record, or NULL if none exist

See also:
  SetInternalCoord

T* CastAndClear | ( | bool | clear = `true` ) | `[inline, inherited]`

By default clears the object. Called from ReadMolecule of most format classes.

bool HasData | ( | const std::string & | s ) | `[inherited]`

Returns:
  whether the generic attribute/value pair exists

Referenced by OBDepict::DrawMolecule(), OBForceField::GetAtomTypes(), OBForceField::GetConformers(), OBForceField::GetCoordinates(), OBMol::GetEnergies(), OBMol::GetEnergy(), OBForceField::GetPartialCharges(), OBDescriptor::MatchPairData(), OBMol::operator=(), and OBMol::SetEnergies().

bool HasData | ( | const char * | s ) | `[inherited]`

Returns:
  whether the generic attribute/value pair exists

bool HasData | ( | const unsigned int | type ) | `[inherited]`

Returns:
  whether the generic attribute/value pair exists, for a given OBGenericDataType

void DeleteData | ( | unsigned int | type ) | `[inherited]`

Delete any data matching the given OBGenericDataType.

Referenced by OpenBabel::CanonicalLabels(), OBDescriptor::DeleteProperties(), and OBMol::RenumberAtoms().

void DeleteData | ( | OBGenericData * | gd ) | `[inherited]`

Delete the given generic data from this object.

void DeleteData | ( | std::vector< OBGenericData * > & | vg ) | `[inherited]`

Delete all of the given generic data from this object.

bool DeleteData | ( | const std::string & | s ) | `[inherited]`

Deletes the generic data with the specified attribute, returning false if not found.

void SetData | ( | OBGenericData * | d ) | `[inline, inherited]`

Adds a data object; does nothing if d==NULL.

Referenced by OBGastChrg::AssignPartialCharges(), OpenBabel::CalcSignedVolume(), OBForceField::GetAtomTypes(), OBForceField::GetConformers(), OBForceField::GetCoordinates(), OBMol::GetEnergies(), OBMol::GetEnergy(), OBMol::GetNextFragment(), OBForceField::GetPartialCharges(), OBMoleculeFormat::MakeCombinedMolecule(), OBDescriptor::PredictAndSave(), and OBMol::SetEnergies().

void CloneData | ( | OBGenericData * | d ) | `[inherited]`

Adds a copy of a data object; does nothing if d == NULL

Since:
  version 2.2

size_t DataSize | ( | ) | const`[inline, inherited]`

Returns:
  the number of OBGenericData items attached to this molecule.

OBGenericData * GetData | ( | const unsigned int | type ) | `[inherited]`

Returns:
  the first matching data for a given type from OBGenericDataType or NULL if nothing matches

Referenced by OpenBabel::CalcSignedVolume(), OpenBabel::CorrectChirality(), OBDepict::DrawMolecule(), OBDescriptor::FilterCompare(), OpenBabel::GetAtomSymClass(), OBForceField::GetAtomTypes(), OBForceField::GetConformers(), OBForceField::GetCoordinates(), OBMol::GetNextFragment(), OBForceField::GetPartialCharges(), OBDescriptor::GetValues(), OBMoleculeFormat::MakeCombinedMolecule(), OBMolAngleIter::OBMolAngleIter(), OBMolRingIter::OBMolRingIter(), OBMolTorsionIter::OBMolTorsionIter(), OBMol::operator=(), and OBDescriptor::PredictAndSave().

OBGenericData * GetData | ( | const std::string & | s ) | `[inherited]`

Returns:
  any data matching the given attribute name or NULL if nothing matches
  the value given an attribute name

OBGenericData * GetData | ( | const char * | s ) | `[inherited]`

Returns:
  any data matching the given attribute name or NULL if nothing matches
  the value given an attribute name

std::vector<OBGenericData*>& GetData | ( | ) | `[inline, inherited]`

Returns:
  all data, suitable for iterating

Referenced by OBMol::GetEnergies(), OBMol::GetEnergy(), and OBMol::SetEnergies().

std::vector< OBGenericData * > GetData | ( | DataOrigin | source ) | `[inherited]`

Returns:
  all data with a specific origin, suitable for iterating

std::vector< OBGenericData * > GetAllData | ( | const unsigned int | type ) | `[inherited]`

Returns:
  the all matching data for a given type from OBGenericDataType or an empty vector if nothing matches

Since:
  version 2.2

Referenced by OpenBabel::CanonicalLabels(), OBBuilder::CorrectStereoAtoms(), and OBBuilder::CorrectStereoBonds().

OBDataIterator BeginData | ( | ) | `[inline, inherited]`

Returns:
  An iterator pointing to the beginning of the data

Referenced by OBAtom::Duplicate(), OBMoleculeFormat::MakeCombinedMolecule(), and OBMol::operator=().

OBDataIterator EndData | ( | ) | `[inline, inherited]`

Returns:
  An iterator pointing to the end of the data

Referenced by OBAtom::Duplicate(), OBMoleculeFormat::MakeCombinedMolecule(), and OBMol::operator=().

## Member Data Documentation

int _flags`[protected]`

bitfield of flags

Referenced by OBMol::OBMol(), and OBMol::PerceiveBondOrders().

bool _autoPartialCharge`[protected]`

Assign partial charges automatically.

Referenced by OBMol::OBMol().

bool _autoFormalCharge`[protected]`

Assign formal charges automatically.

Referenced by OBMol::OBMol().

std::string _title`[protected]`

Molecule title.

Referenced by OBMol::OBMol().

std::vector<OBAtom*> _vatom`[protected]`

vector of atoms

Referenced by OBMol::BeginAtom(), OBMol::NextAtom(), OBMol::OBMol(), and OBMol::RenumberAtoms().

std::vector<OBAtom*> _atomIds`[protected]`

vector of atoms indexed by id

Referenced by OBMol::OBMol().

std::vector<OBBond*> _vbond`[protected]`

vector of bonds

Referenced by OBMol::BeginBond(), OBMol::NextBond(), and OBMol::OBMol().

std::vector<OBBond*> _bondIds`[protected]`

vector of bonds

Referenced by OBMol::OBMol().

unsigned short int _dimension`[protected]`

Dimensionality of coordinates.

Referenced by OBMol::ConnectTheDots(), OBMol::OBMol(), and OBMol::PerceiveBondOrders().

int _totalCharge`[protected]`

Total charge on the molecule.

Referenced by OBMol::OBMol().

unsigned int _totalSpin`[protected]`

Total spin on the molecule (if not specified, assumes lowest possible spin)

double* _c`[protected]`

coordinate array

Referenced by OBMol::ConnectTheDots(), OBMol::OBMol(), OBMol::Rotate(), OBMol::SetConformer(), OBMol::SetConformers(), OBMol::SetCoordinates(), and OBMol::Translate().

std::vector<double*> _vconf`[protected]`

vector of conformers

Referenced by OBMol::Center(), OBMol::ConnectTheDots(), OBMol::CopyConformer(), OBMol::DeleteConformer(), OBMol::OBMol(), OBMol::SetConformer(), OBMol::SetConformers(), OBMol::SetCoordinates(), and OBMol::~OBMol().

double _energy`[protected]`

heat of formation

Referenced by OBMol::OBMol().

unsigned int _natoms`[protected]`

Number of atoms.

Referenced by OBMol::ConnectTheDots(), and OBMol::OBMol().

unsigned int _nbonds`[protected]`

Number of bonds.

Referenced by OBMol::OBMol().

std::vector<OBResidue*> _residue`[protected]`

Residue information (if applicable)

std::vector<OBInternalCoord*> _internals`[protected]`

Internal Coordinates (if applicable)

unsigned short int _mod`[protected]`

Number of nested calls to BeginModify()

Referenced by OBMol::OBMol().

std::vector<OBGenericData*> _vdata`[protected, inherited]`

Custom data.

Referenced by OBMol::OBMol().

The documentation for this class was generated from the following files:

- mol.h
- kekulize.cpp
- mol.cpp
- ring.cpp
- transform.cpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines